| Flutter Impeller |

Public Member Functions | Static Public Member Functions | Static Protected Member Functions | List of all members
impeller::Geometry Class Referenceabstract

`#include <geometry.h>`

Inheritance diagram for impeller::Geometry:

## Public Member Functions
virtual | ~Geometry ()
virtual GeometryResult | GetPositionBuffer (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const =0
virtual GeometryResult::Mode | GetResultMode () const
virtual std::optional< Rect > | GetCoverage (const Matrix &transform) const =0
virtual bool | CoversArea (const Matrix &transform, const Rect &rect) const
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
virtual bool | IsAxisAlignedRect () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Static Public Member Functions
static std::unique_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...

## Static Protected Member Functions
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 55 of file geometry.h.

## Constructor & Destructor Documentation

## ◆ ~Geometry()

virtual impeller::Geometry::~Geometry | ( |  | ) |
| inlinevirtual

Definition at line 57 of file geometry.h.

57 {}

## Member Function Documentation

## ◆ CanApplyMaskFilter()

bool impeller::Geometry::CanApplyMaskFilter | ( |  | ) | const
| virtual

Reimplemented in impeller::CoverGeometry.

Definition at line 128 of file geometry.cc.

128 {
129 return true;
130 }

## ◆ ComputeAlphaCoverage()

virtual Scalar impeller::Geometry::ComputeAlphaCoverage | ( | const Matrix & | transform | ) | const
| inlinevirtual

Reimplemented in impeller::StrokePathGeometry, impeller::CircleGeometry, and impeller::LineGeometry.

Definition at line 124 of file geometry.h.

124 {
125 return 1.0;
126 }

Referenced by impeller::ColorSourceContents::AppliesAlphaForStrokeCoverage(), impeller::TiledTextureContents::Render(), and impeller::SolidColorContents::Render().

## ◆ ComputePositionGeometry()

GeometryResult impeller::Geometry::ComputePositionGeometry | ( | const ContentContext & | renderer,
|  | const Tessellator::VertexGenerator & | generator,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  |
| staticprotected

Definition at line 24 of file geometry.cc.

28 {
29 using VT = SolidFillVertexShader::PerVertexData;
30
31 size_t count = generator.GetVertexCount();
32
33 return GeometryResult{
34 .type = generator.GetTriangleType(),
35 .vertex_buffer =
36 {
37 .vertex_buffer = renderer.GetTransientsBuffer().Emplace(
38 count * sizeof(VT), alignof(VT),
39 [&generator](uint8_t* buffer) {
40 auto vertices = reinterpret_cast<VT*>(buffer);
41 generator.GenerateVertices([&vertices](const Point& p) {
42 *vertices++ = {
43 .position = p,
44 };
45 });
46 FML_DCHECK(vertices == reinterpret_cast<VT*>(buffer) +
47 generator.GetVertexCount());
48 }),
49 .vertex_count = count,
50 .index_type = IndexType::kNone,
51 },
52 .transform = entity.GetShaderTransform(pass),
53 };
54 }

References impeller::HostBuffer::Emplace(), impeller::Tessellator::VertexGenerator::GenerateVertices(), impeller::Entity::GetShaderTransform(), impeller::ContentContext::GetTransientsBuffer(), impeller::Tessellator::VertexGenerator::GetTriangleType(), impeller::Tessellator::VertexGenerator::GetVertexCount(), impeller::kNone, and impeller::GeometryResult::type.

## ◆ ComputeStrokeAlphaCoverage()

Scalar impeller::Geometry::ComputeStrokeAlphaCoverage | ( | const Matrix & | entity,
|  | Scalar | stroke_width
| ) |  |
| static

Compute an alpha value to simulate lower coverage of fractional pixel strokes.

Definition at line 133 of file geometry.cc.

134 {
135 Scalar scaled_stroke_width = transform.GetMaxBasisLengthXY() * stroke_width;
136 // If the stroke width is 0 or greater than kMinStrokeSizeMSAA, don't apply
137 // any additional alpha. This is intended to match Skia behavior.
138 if (scaled_stroke_width == 0.0 || scaled_stroke_width >= kMinStrokeSizeMSAA) {
139 return 1.0;
140 }
141 // This scalling is eyeballed from Skia.
142 return std::clamp(scaled_stroke_width * 2.0f, 0.f, 1.f);
143 }

References impeller::kMinStrokeSizeMSAA, stroke_width, and transform.

Referenced by impeller::LineGeometry::ComputeAlphaCoverage(), impeller::CircleGeometry::ComputeAlphaCoverage(), and impeller::StrokePathGeometry::ComputeAlphaCoverage().

## ◆ CoversArea()

bool impeller::Geometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented in impeller::SuperellipseGeometry, impeller::CircleGeometry, impeller::FillPathGeometry, impeller::EllipseGeometry, impeller::LineGeometry, impeller::RoundRectGeometry, impeller::CoverGeometry, and impeller::RectGeometry.

Definition at line 120 of file geometry.cc.

120 {
121 return false;
122 }

Referenced by impeller::SolidColorContents::AsBackgroundColor().

## ◆ GetCoverage()

virtual std::optional<Rect> impeller::Geometry::GetCoverage | ( | const Matrix & | transform | ) | const
| pure virtual

Implemented in impeller::DlVerticesGeometry, and impeller::RectGeometry.

Referenced by impeller::ColorSourceContents::DrawGeometry(), impeller::ClipContents::GetClipCoverage(), impeller::SolidColorContents::GetCoverage(), impeller::ColorSourceContents::GetCoverage(), impeller::ClipContents::Render(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ GetPositionBuffer()

virtual GeometryResult impeller::Geometry::GetPositionBuffer | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| pure virtual

Implemented in impeller::DlVerticesGeometry, and impeller::RectGeometry.

Referenced by impeller::ColorSourceContents::DefaultCreateGeometryCallback(), impeller::ColorSourceContents::DrawGeometry(), and impeller::ClipContents::Render().

## ◆ GetResultMode()

GeometryResult::Mode impeller::Geometry::GetResultMode | ( |  | ) | const
| virtual

Definition at line 56 of file geometry.cc.

56 {
57 return GeometryResult::Mode::kNormal;
58 }

References impeller::GeometryResult::kNormal.

Referenced by impeller::ColorSourceContents::DrawGeometry().

## ◆ IsAxisAlignedRect()

bool impeller::Geometry::IsAxisAlignedRect | ( |  | ) | const
| virtual

Reimplemented in impeller::SuperellipseGeometry, impeller::CircleGeometry, impeller::EllipseGeometry, impeller::LineGeometry, impeller::RoundRectGeometry, and impeller::RectGeometry.

Definition at line 124 of file geometry.cc.

124 {
125 return false;
126 }

Referenced by impeller::ClipContents::GetClipCoverage().

## ◆ MakeCircle()

std::unique_ptr< Geometry > impeller::Geometry::MakeCircle | ( | const Point & | center,
|  | Scalar | radius
| ) |  |
| static

Definition at line 104 of file geometry.cc.

105 {
106 return std::make_unique<CircleGeometry>(center, radius);
107 }

## ◆ MakeCover()

std::unique_ptr< Geometry > impeller::Geometry::MakeCover | ( |  | ) |
| static

Definition at line 85 of file geometry.cc.

85 {
86 return std::make_unique<CoverGeometry>();
87 }

Referenced by impeller::testing::TEST_P().

## ◆ MakeFillPath()

std::unique_ptr< Geometry > impeller::Geometry::MakeFillPath | ( | const Path & | path,
|  | std::optional< Rect > | inner_rect = `std::nullopt`
| ) |  |
| static

Definition at line 60 of file geometry.cc.

62 {
63 return std::make_unique<FillPathGeometry>(path, inner_rect);
64 }

Referenced by impeller::DlDispatcherBase::clipPath(), impeller::DlDispatcherBase::clipRRect(), impeller::testing::TEST(), and impeller::testing::TEST_P().

## ◆ MakeLine()

std::unique_ptr< Geometry > impeller::Geometry::MakeLine | ( | const Point & | p0,
|  | const Point & | p1,
|  | Scalar | width,
|  | Cap | cap
| ) |  |
| static

Definition at line 97 of file geometry.cc.

100 {
101 return std::make_unique<LineGeometry>(p0, p1, width, cap);
102 }

Referenced by impeller::testing::TEST().

## ◆ MakeOval()

std::unique_ptr< Geometry > impeller::Geometry::MakeOval | ( | const Rect & | rect | ) |
| static

Definition at line 93 of file geometry.cc.

93 {
94 return std::make_unique<EllipseGeometry>(rect);
95 }

Referenced by impeller::DlDispatcherBase::clipOval(), impeller::DlDispatcherBase::clipPath(), and impeller::DlDispatcherBase::clipRRect().

## ◆ MakePointField()

std::unique_ptr< Geometry > impeller::Geometry::MakePointField | ( | std::vector< Point > | points,
|  | Scalar | radius,
|  | bool | round
| ) |  |
| static

Definition at line 66 of file geometry.cc.

68 {
69 return std::make_unique<PointFieldGeometry>(std::move(points), radius, round);
70 }

Referenced by impeller::testing::TEST_P().

## ◆ MakeRect()

std::unique_ptr< Geometry > impeller::Geometry::MakeRect | ( | const Rect & | rect | ) |
| static

Definition at line 89 of file geometry.cc.

89 {
90 return std::make_unique<RectGeometry>(rect);
91 }

Referenced by impeller::DlDispatcherBase::clipPath(), impeller::DlDispatcherBase::clipRect(), impeller::DlDispatcherBase::clipRRect(), impeller::Canvas::DrawVertices(), impeller::testing::TEST(), and impeller::testing::TEST_P().

## ◆ MakeRoundRect()

std::unique_ptr< Geometry > impeller::Geometry::MakeRoundRect | ( | const Rect & | rect,
|  | const Size & | radii
| ) |  |
| static

Definition at line 115 of file geometry.cc.

116 {
117 return std::make_unique<RoundRectGeometry>(rect, radii);
118 }

Referenced by impeller::DlDispatcherBase::clipPath(), impeller::DlDispatcherBase::clipRRect(), and impeller::testing::TEST().

## ◆ MakeStrokedCircle()

std::unique_ptr< Geometry > impeller::Geometry::MakeStrokedCircle | ( | const Point & | center,
|  | Scalar | radius,
|  | Scalar | stroke_width
| ) |  |
| static

Definition at line 109 of file geometry.cc.

111 {
112 return std::make_unique<CircleGeometry>(center, radius, stroke_width);
113 }

References stroke_width.

## ◆ MakeStrokePath()

std::unique_ptr< Geometry > impeller::Geometry::MakeStrokePath | ( | const Path & | path,
|  | Scalar | stroke_width = `0.0`,
|  | Scalar | miter_limit = `4.0`,
|  | Cap | stroke_cap = `Cap::kButt`,
|  | Join | stroke_join = `Join::kMiter`
| ) |  |
| static

Definition at line 72 of file geometry.cc.

76 {
77 // Skia behaves like this.
78 if (miter_limit < 0) {
79 miter_limit = 4.0;
80 }
81 return std::make_unique<StrokePathGeometry>(path, stroke_width, miter_limit,
82 stroke_cap, stroke_join);
83 }

References stroke_width.

Referenced by impeller::testing::TEST(), and impeller::testing::TEST_P().

The documentation for this class was generated from the following files:

- impeller/entity/geometry/geometry.h
- impeller/entity/geometry/geometry.cc

impeller::GeometryResult::Mode::kNormal
@ kNormal
The geometry has no overlapping triangles.
impeller::Scalar
float Scalar
Definition: scalar.h:18
impeller::kMinStrokeSizeMSAA
static constexpr Scalar kMinStrokeSizeMSAA
The minimum stroke size can be less than one physical pixel because of MSAA, but no less that half a ...
Definition: geometry.h:22
stroke_width
const Scalar stroke_width
Definition: stroke_path_geometry.cc:297
impeller::Point
TPoint< Scalar > Point
Definition: point.h:327
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:213
impeller::IndexType::kNone
@ kNone
Does not use the index buffer.